# this script will allow you to have a solo ladder of your own in your very channel 
# use !addaccount to add warcraft 3 the frozen throne accounts to your ladder
# use !remaccount to, well figure it einstein
#
# NOTE: it only collects stats from northrend gateway, if you want it to use another
#       gateway check the script and do the appropriate changes yourself
#
# use !wc3sololadder and the bot will show your private solo ladder, you should add some accounts first
#
# well have fun 
#
# Aj!AOD - may the scene last forever

package require http

bind pub - "!addaccount" pub:addaccount
proc pub:addaccount {nick host hand chan text} {
 if {$text == ""} {
  putchan $chan "\002USAGE:\002 !addaccount <warcraft 3 tft account>"
 } else {
  set wc3account [lindex $text 0]
  set outfile [open "sololadder.wc3" a]
  puts $outfile $wc3account
  close $outfile
  putchan $chan "\002$nick\002, succesfully added \002$wc3account\002 to the ladder"
 }
}

bind pub - "!remaccount" pub:remaccount
proc pub:remaccount {nick host hand chan text} {
 if {$text == ""} {
  putchan $chan "\002USAGE:\002 !remaccount <warcraft 3 tft account>"
 } else {
  set k 0
  set wc3account [lindex $text 0]
  set infile [open "sololadder.wc3" r]
  set outfile [open "sololadder.wc3.tmp" a]
  while {![eof $infile]} {
   gets $infile dataline
   if {$dataline == $wc3account} {
    set k 1
   } else {
    if {$dataline != ""} {
     puts $outfile $dataline
    }
   }
  }
  close $infile
  close $outfile
  exec rm "sololadder.wc3"
  exec mv "sololadder.wc3.tmp" "sololadder.wc3"
  if {$k == 1} {
   putchan $chan "\002$nick\002, succesfully removed \002$wc3account\002 from the ladder"
  } else {
   putchan $chan "\002$nick\002, unable to find \002$wc3account\002, nothing removed"
  }
 }
}

bind pub - "!wc3sololadder" pub:wc3ladder2
proc pub:wc3ladder2 {nick host hand chan text} {
 utimer 4 "wc3sololadder $chan"
 putchan $chan  "\002$nick\002, gathering information, hold on this may take a few secs..."
}

proc wc3sololadder {chan} {
 set allsolostats "696969 wc3acc sololevel solowins sololoses -696969 wc3acc sololevel solowins sololoses"
 set infile [open "sololadder.wc3" r]
 set wc3accounts ""
 while {![eof $infile]} {
  gets $infile dataline  
  append wc3accounts "$dataline "
 }
 close $infile
 for {set i 0} {$i<[llength $wc3accounts]} {incr i} {
  set wc3account [lindex $wc3accounts $i]
  set solostats [wc3stats $wc3account]   
  if {$solostats != "noplayerfound" || $solostats != "nogamesplayedyet"} {
   set k2 0
   for {set i2 0} {$i2<[llength $allsolostats]} {incr i2;incr i2;incr i2;incr i2;incr i2} {
    set zahl $i2
    set efficency1 [lindex $allsolostats $zahl]
    set zahl [expr $i2+5]
    set efficency2 [lindex $allsolostats $zahl]
    set zahl [expr $i2+4]
    set part1 [lrange $allsolostats 0 $zahl]
    set zahl [expr $i2+5]
    set part2 [lrange $allsolostats $zahl end]
    set efficency [lindex $solostats 0]
    if {$k2 == 0} {
     if {$efficency == $efficency1 } {
      set k2 1
      set allsolostats "$part1 $efficency $wc3account $solostats $part2"
     }
     if {$efficency < $efficency1 && $efficency > $efficency2} {
      set allsolostats "$part1 $efficency $wc3account $solostats $part2"
      set k2 1
     }
    } 
   }  
  }   
 }    
 set c 0
 putchan $chan  "\002WARCRAFT 3 THE FROZEN THRONE 1ON1 LADDER (NORTHREND)\002"
 putchan $chan "----------------------------------------------------------"    
 for {set i2 0} {$i2<[llength $allsolostats]} {incr i2;incr i2;incr i2;incr i2;incr i2} {
  incr c
  set zahl [expr 6+$i2]
  set wc3account [lindex $allsolostats $zahl]
  set zahl [expr 7+$i2]
  set sololevel [lindex $allsolostats $zahl]
  set zahl [expr 8+$i2]
  set solowins [lindex $allsolostats $zahl]
  set zahl [expr 9+$i2]
  set sololoses [lindex $allsolostats $zahl]
  if {$wc3account != "" && $wc3account != "wc3acc"} {
   putchan $chan "\002#$c\002 is \002$wc3account\002 with Level: \002$sololevel\002 Wins: \002$solowins\002 Losses: \002$sololoses\002"
  }
 } 
}  

proc wc3stats {wc3account} {
 ::http::config -useragent lm.tcl
 set tok [::http::geturl "www.battle.net/war3/ladder/W3XP-player-profile.aspx?Gateway=Northrend&PlayerName=$wc3account"]
 set data [::http::data $tok]
 regsub -all {<.*?>}  $data {}    data
 regsub -all {&nbsp;} $data { }   data
 regsub -all {&lt;}   $data {<}   data
 regsub -all {&gt;}   $data {>}   data
 regsub -all {&quot;} $data {\\"} data
 regsub -all {&#39;}  $data {'}   data
 regsub -all {&#91;}  $data {\\[} data
 regsub -all {&#93;}  $data {\\]} data
 regsub -all {&copy;} $data {)}   data
 regsub -all {&amp;}  $data {&}   data
 regsub -all {^{\n}}  $data {}    data
        
 set solok 0
 set sololevel 0
 set solowins 0 
 set sololoses 0
 set playernotfound 0
 foreach {a} [split $data \n] {
  set line [lrange [split $a] 0 end]
  set line2 ""
  for {set i 0} {$i<[string length $line]} {incr i} {
   set chr [string index $line $i]
   set k 0
   if {$chr == "\}"} {set k 1}
   if {$chr == "\{"} {set k 1}
   if {$chr == "\""} {set k 1}
   if {$k == 0} {append line2 $chr}
  }
  set line [lrange $line2 0 end]
  if {$line == "Object moved to here."} {set playernotfound 1}
  if {$line != ""} {
   set data1 [lindex $line 0]
   set data2 [lindex $line 1]
   if {$solok == 4} {set sololevel $data1}
   if {$solok == 10} {set solowins $data1}
   if {$solok == 12} {set sololoses $data1;set solok -1}
   if {$solok > 0} {incr solok}
   if {$data1 == "Solo" && $data2 == "Games"} {incr solok}
  }
 } 
 if {$playernotfound == 1} {
  return "noplayerfound"
 } else {
  if {$solok == 0} {
   return "nogamesplayedyet"
  } else {
   return "$sololevel $solowins $sololoses"
  }
 } 
}  

# EOF Aj!AOD